/* ******** netUstad: Network Ustadi (Network Master) ******** */
/* This software is Copyright (C) 2004 by Ozkan KIRIK.        */
/* Permission is granted to redistribute and modify this      */
/* software under the terms of the GNU General Public License */
/* available at http://www.gnu.org/                           */
/**************************************************************/


#include "acceptrequest.h"
#include "netustad.h"
#include "loadconfig.h"
#include "addnewrule.h"
#include "deleterule.h"
#include "editrule.h"
#include "mimetype.h"
#include "auth.h"

/******************/
/* Manage Request */
/******************/
void 
accept_request(int client)
{
	int		numchars;
	int		auth_form = 0;
	int		p = 0;
	char		buf       [1024];
	char		method    [255];
	char		url       [255];
	char		path      [512],
			parameters    [512];
	char		env_str   [512];
	char           *env_p[6];
	size_t		i      ,
			j;
	struct stat	st;
	int		cgi = 0;/* becomes true if server decides this is a
				 * CGI program */
	char		query_string[255];
	char           *tmp_str = NULL;
	char           *tmp_url = NULL;
	char           *client_sid = " ";

	numchars = get_line(client, buf, sizeof(buf));

	i = 0;
	j = 0;
	while (!ISspace(buf[j]) && (i < sizeof(method) - 1)) {
		method[i] = buf[j];
		i++;
		j++;
	}
	method[i] = '\0';

	/***************************************/
	/* Directly Unimplementing POST Method */
	/***************************************/
	if (strcasecmp(method, "GET") != 0) {	/* && strcasecmp(method,
						 * "POST")) */
		unimplemented(client);
		return;
	}
	if (strcasecmp(method, "POST") == 0)
		cgi = 1;

	i = 0;
	while (ISspace(buf[j]) && (j < sizeof(buf)))
		j++;
	while (!ISspace(buf[j]) && (i < sizeof(url) - 1) && (j < sizeof(buf))) {
		url[i] = buf[j];
		i++;
		j++;
	}
	url[i] = '\0';

	i = 0;
	j = 0;
	if (strcasecmp(method, "GET") == 0) {
		strncpy(query_string, url, sizeof(query_string));
		while ((query_string[i] != '?') && (query_string[i] != '\0'))
			i++;
		if (query_string[i] == '?') {
			cgi = 1;
			url[i] = '\0';
			i++;
			while ((i < sizeof(query_string)) && (query_string[i] != '\0'))
				query_string[j++] = query_string[i++];
			query_string[j] = '\0';
		} else
			query_string[0] = '\0';
	}
	/*******************/
	/* Parse SessionID */
	/*******************/
	if (query_string[0] == 0) {
		tmp_str = url;
		tmp_url = strtok(tmp_str, "$\n");
		while ((*tmp_url != NULL) && ((int)p < (int)strlen(url)))
			url[p++] = *tmp_url++;
		url[p] = '\0';
	} else {
		tmp_str = strdup(query_string);
		strncpy(query_string, strtok(tmp_str, "$\n"), sizeof(query_string));
	}
	client_sid = strtok(NULL, "$\n");
	if (client_sid == 0)
		client_sid = "$";

	/****************************/
	/* add script folder to url */
	/****************************/
	snprintf(path, sizeof(path), "script%s", url);

	/*****************************/
	/* Check Unwanted Characters */
	/*****************************/
	if ((strstr(path, "..") != NULL) || \
		(strstr(path, "`") != NULL) || \
		(strstr(path, "\"") != NULL) || \
		(strstr(path, "'") != NULL) || \
		(strstr(path, "|") != NULL) || \
		(strstr(path, ">") != NULL) || \
		(strstr(path, "<") != NULL) || \
		(strstr(path, "[") != NULL) || \
		(strstr(path, "]") != NULL) || \
		(strstr(path, "%20") != NULL) || \
		(strstr(path, "%22") != NULL) || \
		(strstr(path, "%60") != NULL) || \
		(strstr(query_string, "`") != NULL) || \
		(strstr(query_string, "\"") != NULL) || \
		(strstr(query_string, "'") != NULL) || \
		(strstr(query_string, "|") != NULL) || \
		(strstr(query_string, ">") != NULL) || \
		(strstr(query_string, "<") != NULL) || \
		(strstr(query_string, "[") != NULL) || \
		(strstr(query_string, "]") != NULL) || \
		(strstr(query_string, "%20") != NULL) || \
		(strstr(query_string, "%22") != NULL) || \
		(strstr(query_string, "%60") != NULL) ) {
		server_sid[0] = '$';
		server_sid[1] = '\0';
		log_msg(mainlogfile, strtok(ctime(&currentsec), "\n"));
		snprintf(parameters, sizeof(parameters), " -- Bad Request From: %s. The Req. is: %s\n", \
			 (char *)inet_ntoa(client_name.sin_addr), path);
		log_msg(mainlogfile, parameters);
		log_msg(mainlogfile, strtok(ctime(&currentsec), "\n"));
		log_msg(mainlogfile, " -- Session Killed Because of Bad Request\n");
		snprintf(auth_msg, sizeof(auth_msg), " ");
		auth_form = 1;
	}
	/************************/
	/* Check Session Expire */
	/************************/
	time(&currentsec);
	/*
	 * if ((long)currentsec-(long)lastactionsec<=300) { *//* Session Not
	 * Expired
	 */
	if ((long)currentsec - (long)lastactionsec <= sesexpiretime) {	/* Session Not Expired */
		time(&lastactionsec);
	} else {		/* Session Expired, close session */
		server_sid[0] = '$';
		server_sid[1] = '\0';
		log_msg(mainlogfile, strtok(ctime(&currentsec), "\n"));
		log_msg(mainlogfile, " -- Administrator's Session Expired!\n");
		snprintf(auth_msg, sizeof(auth_msg), "Session Expired!");
		auth_form = 1;
	}


	/********************/
	/* Check Session ID */
	/********************/
	if (strcmp(server_sid, "$") != 0 && *client_sid != '$')
		if (strcmp(client_sid, server_sid) != 0 || \
		    strcmp(client_ip, (char *)inet_ntoa(client_name.sin_addr)) != 0) {
			snprintf(auth_msg, sizeof(auth_msg), "You are not logged in!");
			auth_form = 1;
		} else
			auth_form = 0;
	else {
		if ((long)lastactionsec == 0)
			snprintf(auth_msg, sizeof(auth_msg), " ");
		auth_form = 1;
	}

	/********************************/
	/* Define Environment Variables */
	/********************************/
	snprintf(env_str, sizeof(env_str), "netustadversion=%s", VERSION);
	env_p[0] = strdup(env_str);	/* netustadversion */
	snprintf(env_str, sizeof(env_str), "work_path=%sscript", workdir);
	env_p[1] = strdup(env_str);	/* work_path */
	snprintf(env_str, sizeof(env_str), "auth_msg=%s", auth_msg);
	env_p[2] = strdup(env_str);	/* auth_msg */
	snprintf(env_str, sizeof(env_str), "server_sid=%s", server_sid);
	env_p[3] = strdup(env_str);
	env_p[4] = NULL;	/* temporary variable */
	env_p[5] = NULL;	/* parameter terminate */

	/***************************/
	/* Parse Requested Address */
	/***************************/

	/* If Logout Requested Close Session and Goto Auth */
	if (rightcmp(path, "/logout")) {
		server_sid[0] = '$';
		server_sid[1] = '\0';
		snprintf(auth_msg, sizeof(auth_msg), "You are logged out.");
		log_msg(mainlogfile, strtok(ctime(&currentsec), "\n"));
		log_msg(mainlogfile, " -- Administrator logged out\n");
		auth_form = 1;
	} else if (rightcmp(path, "/images/bg.png")) {
		snprintf(path, sizeof(path), "script/images/bg.png");
	} else if (rightcmp(path, "/images/buton_0.png")) {
		snprintf(path, sizeof(path), "script/images/buton_0.png");
	} else if (rightcmp(path, "/images/buton_1.png")) {
		snprintf(path, sizeof(path), "script/images/buton_1.png");
	} else if (rightcmp(path, "/images/buton_2.png")) {
		snprintf(path, sizeof(path), "script/images/buton_2.png");
	} else if (rightcmp(path, "/images/buton_3.png")) {
		snprintf(path, sizeof(path), "script/images/buton_3.png");
	} else if (rightcmp(path, "/images/menu_login.png")) {
		snprintf(path, sizeof(path), "script/images/menu_login.png");
	} else if (rightcmp(path, "/images/buton_4.png")) {
		snprintf(path, sizeof(path), "script/images/buton_4.png");
	} else if (rightcmp(path, "/images/buton_5.png")) {
		snprintf(path, sizeof(path), "script/images/buton_5.png");
	} else if (rightcmp(path, "/images/buton_7.png")) {
		snprintf(path, sizeof(path), "script/images/buton_7.png");
	} else if (rightcmp(path, "/images/banner.png")) {
		snprintf(path, sizeof(path), "script/images/banner.png");
	} else if (rightcmp(path, "/images/banner-alt.png")) {
		snprintf(path, sizeof(path), "script/images/banner-alt.png");
	} else if (rightcmp(path, "/netustad.css")) {
		snprintf(path, sizeof(path), "script/netustad.css");
	}
	/* Other Requests */
	if (auth_form == 1 && \
	    !(rightcmp(path, "/auth")) && \
	    !(rightcmp(path, "/netustad.css")) && \
	    !(rightcmp(path, "/images/bg.png")) && \
	    !(rightcmp(path, "/images/buton_0.png")) && \
	    !(rightcmp(path, "/images/buton_1.png")) && \
	    !(rightcmp(path, "/images/buton_2.png")) && \
	    !(rightcmp(path, "/images/buton_3.png")) && \
	    !(rightcmp(path, "/images/buton_4.png")) && \
	    !(rightcmp(path, "/images/buton_5.png")) && \
	    !(rightcmp(path, "/images/buton_6.png")) && \
	    !(rightcmp(path, "/images/buton_7.png")) && \
	    !(rightcmp(path, "/images/banner.png")) && \
	    !(rightcmp(path, "/images/banner-alt.png")) && \
	    !(rightcmp(path, "/images/menu_login.png"))) {
		snprintf(env_str, sizeof(env_str), "auth_msg=%s", auth_msg);
		env_p[2] = strdup(env_str);
		snprintf(path, sizeof(path), "script/authform");
	} else if (path[strlen(path) - 1] == '/') {
		snprintf(env_str, sizeof(env_str), "work_path=%s/script", workdir);
		env_p[1] = strdup(env_str);
		snprintf(env_str, sizeof(env_str), "server_sid=%s", server_sid);
		env_p[3] = strdup(env_str);
		strncat(path, "showrule", (size_t) (sizeof(path) - strlen(path)));
	} else if (rightcmp(path, "/edit")) {
		snprintf(env_str, sizeof(env_str), "work_path=%s/script", workdir);
		env_p[1] = strdup(env_str);
		snprintf(env_str, sizeof(env_str), "server_sid=%s", server_sid);
		env_p[3] = strdup(env_str);
		snprintf(env_str, sizeof(env_str), "ruleno=%s", query_string);
		env_p[4] = strdup(env_str);
		strncat(path, "form", (size_t) (sizeof(path) - strlen(path)));
	} else if (rightcmp(path, "/auth") && auth_form == 1) {
		snprintf(path, sizeof(path), "%s", auth(query_string));
		snprintf(env_str, sizeof(env_str), "auth_msg=%s", auth_msg);
		env_p[2] = strdup(env_str);
		snprintf(env_str, sizeof(env_str), "server_sid=%s", server_sid);
		env_p[3] = strdup(env_str);
	}
	/* If Rule Deleting Requested ("del" word) */
	if (rightcmp(path, "/del")) {
		strncpy(path, "/sbin/ipfw", sizeof(path));
		snprintf(parameters, sizeof(parameters), "delete");
		deleterule(client, path, parameters, method, query_string);
	} else if (rightcmp(path, "/addnew")) {
		strncpy(path, "/sbin/ipfw", sizeof(path));
		addnewrule(client, path, method, query_string);
	} else if (rightcmp(path, "/applyedit")) {
		strncpy(path, "/sbin/ipfw", sizeof(path));
		editrule(client, path, method, query_string);
	} else if (stat(path, &st) == -1) {
		while ((numchars > 0) && strcmp("\n", buf))	/* read & discard
								 * headers */
			numchars = get_line(client, buf, sizeof(buf));
		log_msg(logfile, path);
		log_msg(logfile, "\n");
		not_found(client);
	} else {
		if ((st.st_mode & S_IFMT) == S_IFDIR)
			strncat(path, "/showrule", (size_t) (sizeof(path) - strlen(path)));
		if ((st.st_mode & S_IXUSR) ||
		    (st.st_mode & S_IXGRP) ||
		    (st.st_mode & S_IXOTH))
			cgi = 1;
		if (!cgi)
			serve_file(client, path);
		else
			execute_cgi(client, path, method, query_string, env_p);
	}
}

/******************************/
/* Send client a regular file */
/******************************/
void 
serve_file(int client, char *filename)
{
	FILE           *resource = NULL;
	int		numchars = 1;
	char		buf       [1024];

	buf[0] = 'A';
	buf[1] = '\0';
	while ((numchars > 0) && strcmp("\n", buf))	/* read & discard
							 * headers */
		numchars = get_line(client, buf, sizeof(buf));
	resource = fopen(filename, "r");
	if (resource == NULL)
		not_found(client);
	else {
		if (headers(client, filename) == 1) {
			if (strcmp(mimetype(filename), "text/html") != 0 && \
			    strcmp(mimetype(filename), "text/css") != 0)
				binarycat(client, resource);
			else
				cat(client, resource);
		}
	}
	fclose(resource);
}


/*********************************/
/* Compare two string from right */
/*********************************/
/* For example:                  */
/* str="abcd"; look4str="cd" */
/* rightcmp(str,look4str) = 1    */
/* str="abcd"; look4str="ab" */
/* rightcmp(str,look4str) = 0    */
/*********************************/
int 
rightcmp(char *str, char *look4str)
{
	int		i = 0;

	if (look4str == NULL || str == NULL) {
		return 0;
	}			/* Oopps, invalid number of args */
	if (strlen(look4str) > strlen(str)) {	/* If look4str is longer then
						 * str, compare cannot be
						 * done */
		return 0;
	}
	for (i = strlen(look4str); i >= 1; i--) {
		if ((char)str[strlen(str) - i] != (char)look4str[strlen(look4str) - i]) {
			return 0;
		}
	}
	return 1;
}
