/* ******** netUstad: Network Ustadi (Network Master) ******** */
/* This software is Copyright (C) 2004 by Ozkan KIRIK.        */
/* Permission is granted to redistribute and modify this      */
/* software under the terms of the GNU General Public License */
/* available at http://www.gnu.org/                           */
/**************************************************************/


#include "editrule.h"
#include "netustad.h"
#include "loadconfig.h"

/***************************************************************/
/* Editing An IPFW Rule                                        */
/***************************************************************/
void 
editrule(int client, const char *path,
	 const char *method, char *query_string)
{
	char		buf       [1024],
			tmpbuf        [255];
	char		log_string[512];
	FILE           *resource = NULL;
	int		cgi_output [2];
	int		cgi_input  [2];
	pid_t		pid;
	int		numchars = 1;
	int		status;
	char		c;
	char           *param[64];
	char           *tempstr;
	char           *delruleno;
	int		pos = 2;


	buf[0] = 'A';
	buf[1] = '\0';
	if (strcasecmp(method, "GET") == 0)
		while ((numchars > 0) && strcmp("\n", buf))	/* read & discard
								 * headers */
			numchars = get_line(client, buf, sizeof(buf));
	else {			/* POST */
		unimplemented(client);
		return;
	}

	if (strlen(query_string) < 13) {
		unimplemented(client);
		return;
	}
	snprintf(buf, sizeof(buf), "HTTP/1.0 200 OK\r\nContent-Type: text/html\r\n\r\n");
	send(client, buf, strlen(buf), 0);

	param[0] = strdup(path);
	param[1] = "add";
	tempstr = strdup(query_string);

	delruleno = strdup(strtok(tempstr, "@\n"));
	param[pos] = strtok(NULL, "@\n");
	while (param[pos++] != NULL) {
		param[pos] = strtok(NULL, "@\n");
	}

	/* Deleting Old Rule */
	if (pipe(cgi_output) < 0) {
		cannot_execute(client);
		return;
	}
	if (pipe(cgi_input) < 0) {
		cannot_execute(client);
		return;
	}
	if ((pid = fork()) < 0) {
		cannot_execute(client);
		return;
	}
	if (pid == 0) {		/* child: Delete Rule */
		dup2(cgi_output[1], 1);
		dup2(cgi_input[0], 0);
		close(cgi_output[0]);
		close(cgi_input[1]);

		execl(path, path, "del", delruleno, NULL);
		exit(0);
	} else {		/* parent */
		close(cgi_output[1]);
		close(cgi_input[0]);
		while (read(cgi_output[0], &c, 1) > 0)
			send(client, &c, 1, 0);
		close(cgi_output[0]);
		close(cgi_input[1]);

		waitpid(pid, &status, 0);
	}

	/* Adding New Rule  */
	if (pipe(cgi_output) < 0) {
		cannot_execute(client);
		return;
	}
	if (pipe(cgi_input) < 0) {
		cannot_execute(client);
		return;
	}
	if ((pid = fork()) < 0) {
		cannot_execute(client);
		return;
	}
	if (pid == 0) {		/* child: Add new rule */
		dup2(cgi_output[1], 1);
		dup2(cgi_input[0], 0);
		close(cgi_output[0]);
		close(cgi_input[1]);
		execv(path, param);
		exit(0);
	} else {		/* parent */
		close(cgi_output[1]);
		close(cgi_input[0]);
		pos = 0;
		while (read(cgi_output[0], &c, 1) > 0)
			tmpbuf[pos++] = c;
		tmpbuf[pos] = '\0';

		/* Log Request  */
		time(&currentsec);
		timenow = strtok(ctime(&currentsec), "\n");
		snprintf(log_string, sizeof(log_string), "%s -- IP: %s Edit Rule: %s is replaced with %s", \
			 (char *)timenow, \
			 (char *)inet_ntoa(client_name.sin_addr), \
			 (char *)delruleno, \
			 (char *)tmpbuf);
		log_msg(logfile, log_string);

		snprintf(buf, sizeof(buf), "<html><head><meta http-equiv='Refresh' content='2; URL=/$%s'>\n\
	<meta http-equiv='Pragma' content='no-cache'>\n\
        <title>netUstad</title></head><style>\n", server_sid);
		send(client, buf, strlen(buf), 0);
		resource = fopen("script/netustad.css", "r");
		cat(client, resource);
		fclose(resource);
		snprintf(buf, sizeof(buf), "</style>\n<body><center>\n<br><b>Edit Complete<b><br>Redirecting to Rule List</body></html>");
		send(client, buf, strlen(buf), 0);
		close(cgi_output[0]);
		close(cgi_input[1]);

		waitpid(pid, &status, 0);
	}
}
